#!/usr/local/bin/python

#Copyright (C) 2006 by raptor
#
#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

# rename files with pattern
# author : raptor@we8log.com
# spec. thanks : topcat
# create : 2006/12/15
# revision : 2006/12/30
# rev. 2.0 : 2009/01/12
#   增加默认从文件名开始处匹配的限制
#   修改了参数定义以方便使用

import os
import getopt
import sys
import re
import types

dest_pattern = re.compile( "(.*?)\$([0-9c])(.*)" )
type_pattern = re.compile( "%\((\$[0-9])\)[0-9]*d" )

def parseDestPattern( pattern ) :
    result = ""
    s = pattern
    while s != "" :
        m = dest_pattern.findall( s )
        if len(m) > 0 :
            m = m[0]
            if m[0][-2:] == "%(" :
                result += m[0] + "$" + m[1]
            else :
                result += m[0] + "%($" + m[1] + ")s"
            s = m[2]
        else :
            result += s
            s = ""
    return result

def changeType( srcdict, destpat ) :
    m = type_pattern.findall( destpat )
    for di in m :
        srcdict[di] = int( srcdict[di] )
    return srcdict

def genNewname( srcmat, destpat, c ) :
    srcdict = {}
    i = 1
    real_srcmat = srcmat[0]
    if (type(real_srcmat) is types.StringType):
        real_srcmat = (real_srcmat , )
    for mat in real_srcmat :
        diname = "$%d" % i
        srcdict[diname] = mat
        i += 1
    srcdict["$c"] = c
    srcdict = changeType( srcdict, destpat )
    print destpat
    print srcdict
    return destpat % srcdict

if __name__ == "__main__" :
    options, args = getopt.getopt(sys.argv[1:], "rni")
    if len(args) < 2:
        print """
Usage : renpat.py [-r] [-n] srcpattern destpattern [dir]
    -r : recursive subdirectories
    -n : no test
    srcpattern  : source pattern(support regular expression)
    destpattern : destination pattern

    eg.1 : renpat.py (.*?)\\.jpg prefix$1.jpg -- aa.jpg => prefixaa.jpg
    eg.2 : renpat.py (.*?)\\.jpg $1%($c)02d.jpg -- aa.jpg => aa00.jpg
    eg.3 : renpat.py (.*?)([0-9]*?)\\.jpg $1%($2)03d.jpg --aa11.jpg => aa011.jpg
"""
    else:
        opts=dict(options)
        subdir = "-r" in opts.keys()
        testdo = not "-n" in opts.keys()
        walkdir = "."
        if len(args)>=3:
            walkdir = args[2]
        srcpat = re.compile(r"^"+args[0])
        destpat = parseDestPattern(args[1])
        print destpat
        for root, dirs, files in os.walk( walkdir ) :
            if subdir or root == walkdir :
                c = 0
                for filename in files :
                    try :
                        srcmat = srcpat.findall( filename )
                        if len(srcmat) == 0 :
                            raise IndexError
                        newname = genNewname( srcmat, destpat, c )
                    except IndexError:
                        continue
                    print "%s\t=>\t%s" % (filename, newname)
                    if ( not testdo ) and ( newname != filename ) :
                        os.rename( os.path.join( root, filename ), os.path.join( root, newname ) )
                    c += 1
